clear; clc; close all;
%% Problem 3.a
% Sample a Lissajous curve
a = 3; b = 2;
delta = pi/2;
n = 100;

t = linspace(0,2*pi,n);
x = sin(a*t*delta);
y = sin(b*t);
z = .5*t;
xyz = [x; y; z];

% Compute point differences and midpoints
diff = xyz(:,2:end)-xyz(:,1:end-1);
midpoint = (xyz(:,1:end-1)+xyz(:,2:end))/2;

binormal = zeros(3,n-2);
%%% YOUR CODE TO COMPUTE THE BINORMAL HERE %%%
%%% END HOMEWORK PROBLEM %%%

figure;
plot3(x,y,z,'linewidth',2,'color','black'); hold on;
quiver3(x(2:end-1),y(2:end-1),z(2:end-1),...
    binormal(1,:),binormal(2,:),binormal(3,:),...
    'color','red','linewidth',1);
axis equal;

%% Problem 3.b
u = zeros(3,n-1);
v = zeros(3,n-1);

h = figure;
figure(h);
scale=0.25;
plot3(x,y,z,'linewidth',2,'color','black'); hold on;
quiv1 = quiver3(midpoint(1,:),midpoint(2,:),midpoint(3,:),...
    scale*u(1,:),scale*u(2,:),scale*u(3,:),...
    'color','red','linewidth',1);
quiv2 = quiver3(midpoint(1,:),midpoint(2,:),midpoint(3,:),...
    scale*v(1,:),scale*v(2,:),scale*v(3,:),...
    'color','blue','linewidth',1);
hold off;
axis manual;
axis equal;
axis([-2 2 -2 2 0 4]);

for a=0:5:360
    t = diff(:,1)/norm(diff(:,1));
    frame0 = cross(t,[0;0;1]);
    frame1 = cross(frame0,t);
    
    theta = a*pi/180;
    u(:,1) = cos(theta).*frame0+sin(theta).*frame1;
    v(:,1) = -sin(theta).*frame0+cos(theta).*frame1;
    for j=2:(n-1)
        %%% YOUR CODE TO UPDATE u, v HERE %%%
        %%% END HOMEWORK PROBLEM %%%
    end
    quiv1.UData = scale*u(1,:); quiv1.VData = scale*u(2,:); quiv1.WData = scale*u(3,:); 
    quiv2.UData = scale*v(1,:); quiv2.VData = scale*v(2,:); quiv2.WData = scale*v(3,:);
    drawnow;
end

%% Problem 3.c
thetas = linspace(0,3*pi,n-1);
m1 = cos(thetas).*u+sin(thetas).*v;
m2 = -sin(thetas).*u+cos(thetas).*v;

figure;
plot3(x,y,z,'linewidth',2,'color','black'); hold on;
quiv1 = quiver3(midpoint(1,:),midpoint(2,:),midpoint(3,:),...
    scale*m1(1,:),scale*m1(2,:),scale*m1(3,:),...
    'color','red','linewidth',1);
quiv2 = quiver3(midpoint(1,:),midpoint(2,:),midpoint(3,:),...
    scale*m2(1,:),scale*m2(2,:),scale*m2(3,:),...
    'color','blue','linewidth',1);
hold off;
axis manual;
axis equal;
axis([-2 2 -2 2 0 4]);

nSteps = 2000;
eps = 1e-6;
grad = zeros(n);
thetas = mod(linspace(0,3*pi,n),2*pi);
for iter=1:nSteps
    %%% YOUR CODE TO COMPUTE TWIST ENERGY AND GRADIENT %%%
    %%% END HOMEWORK PROBLEM %%%
    stepSize = 0.1;
    thetas = thetas-stepSize*grad;
    m1 = cos(thetas).*u+sin(thetas).*v;
    m2 = -sin(thetas).*u+cos(thetas).*v;
    quiv1.UData = scale*m1(1,:); quiv1.VData = scale*m1(2,:); quiv1.WData = scale*m1(3,:);
    quiv2.UData = scale*m2(1,:); quiv2.VData = scale*m2(2,:); quiv2.WData = scale*m2(3,:);
    drawnow
end